Index: pjproject/trunk/pjsip/include/pjsua-lib/pjsua.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsua-lib/pjsua.h	(revision 475)
+++ pjproject/trunk/pjsip/include/pjsua-lib/pjsua.h	(revision 476)
@@ -49,5 +49,5 @@
  */
 #ifndef PJSUA_MAX_BUDDIES
-#   define PJSUA_MAX_BUDDIES	    32
+#   define PJSUA_MAX_BUDDIES	    256
 #endif
 
@@ -62,24 +62,10 @@
 
 /**
- * Aditional ports to be allocated in the conference ports for non-call
- * streams.
- */
-#define PJSUA_CONF_MORE_PORTS	    3
-
-
-/**
  * Maximum accounts.
  */
 #ifndef PJSUA_MAX_ACC
-#   define PJSUA_MAX_ACC	    8
+#   define PJSUA_MAX_ACC	    32
 #endif
 
-
-/**
- * Maximum credentials.
- */
-#ifndef PJSUA_MAX_CRED
-#   define PJSUA_MAX_CRED	    PJSUA_MAX_ACC
-#endif
 
 
@@ -141,4 +127,39 @@
 
 /**
+ * Account configuration.
+ */
+struct pjsua_acc_config
+{
+    /** SIP URL for account ID (mandatory) */
+    pj_str_t	    id;
+
+    /** Registrar URI (mandatory) */
+    pj_str_t	    reg_uri;
+
+    /** Optional contact URI */
+    pj_str_t	    contact;
+
+    /** Service proxy (default: none) */
+    pj_str_t	    proxy;
+
+    /** Default timeout (mandatory) */
+    pj_int32_t	    reg_timeout;
+
+    /** Number of credentials. */
+    unsigned	    cred_count;
+
+    /** Array of credentials. */
+    pjsip_cred_info cred_info[4];
+
+};
+
+
+/**
+ * @see pjsua_acc_config
+ */
+typedef struct pjsua_acc_config pjsua_acc_config;
+
+
+/**
  * Account
  */
@@ -146,17 +167,12 @@
 {
     int		     index;	    /**< Index in accounts array.	*/
-    pj_str_t	     local_uri;	    /**< Uri in From: header.		*/
     pj_str_t	     user_part;	    /**< User part of local URI.	*/
     pj_str_t	     host_part;	    /**< Host part of local URI.	*/
-    pj_str_t	     contact_uri;   /**< Uri in Contact: header.	*/
-
-    pj_str_t	     reg_uri;	    /**< Registrar URI.			*/
+
     pjsip_regc	    *regc;	    /**< Client registration session.   */
-    pj_int32_t	     reg_timeout;   /**< Default timeout.		*/
     pj_timer_entry   reg_timer;	    /**< Registration timer.		*/
     pj_status_t	     reg_last_err;  /**< Last registration error.	*/
     int		     reg_last_code; /**< Last status last register.	*/
 
-    pj_str_t	     proxy;	    /**< Proxy URL.			*/
     pjsip_route_hdr  route_set;	    /**< Route set.			*/
 
@@ -168,5 +184,189 @@
 
 
+/**
+ * @see pjsua_acc
+ */
 typedef struct pjsua_acc pjsua_acc;
+
+
+/**
+ * PJSUA settings.
+ */
+struct pjsua_config
+{
+    /** SIP UDP signaling port. Set to zero to disable UDP signaling,
+     * which in this case application must manually add a transport
+     * to SIP endpoint.
+     * (default: 5060) 
+     */
+    unsigned	udp_port;
+
+    /** Optional hostname or IP address to publish as the host part of
+     *  Contact header. This must be specified if UDP transport is
+     *  disabled.
+     *  (default: NULL)
+     */
+    pj_str_t	sip_host;
+
+    /** Optional port number to publish in the port part of Contact header.
+     *  This must be specified if UDP transport is disabled.
+     *  (default: 0)
+     */
+    unsigned	sip_port;
+
+    /** Start of RTP port. Set to zero to prevent pjsua from creating
+     *  media transports, which in this case application must manually
+     *  create media transport for each calls.
+     *  (default: 4000) 
+     */
+    unsigned	start_rtp_port;
+
+    /** Maximum calls to support (default: 4) */
+    unsigned	max_calls;
+
+    /** Maximum slots in the conference bridge (default: 0/calculated
+     *  as max_calls*2
+     */
+    unsigned	conf_ports;
+
+    /** Number of worker threads (default: 1) */
+    unsigned	thread_cnt;
+
+    /** First STUN server IP address. When STUN is configured, then the
+     *  two STUN server settings must be fully set.
+     *  (default: none) 
+     */
+    pj_str_t	stun_srv1;
+
+    /** First STUN port number */
+    unsigned	stun_port1;
+
+    /** Second STUN server IP address */
+    pj_str_t	stun_srv2;
+
+    /** Second STUN server port number */
+    unsigned	stun_port2;
+
+    /** Internal clock rate (to be applied to sound devices and conference
+     *  bridge, default is 0/follows the codec, or 44100 for MacOS).
+     */
+    unsigned	clock_rate;
+
+    /** Do not use sound device (default: 0). */
+    pj_bool_t	null_audio;
+
+    /** WAV file to load for auto_play (default: NULL) */
+    pj_str_t	wav_file;
+
+    /** Auto play WAV file for calls? (default: no) */
+    pj_bool_t	auto_play;
+
+    /** Auto loopback calls? (default: no) */
+    pj_bool_t	auto_loop;
+
+    /** Automatically put calls to conference? (default: no) */
+    pj_bool_t	auto_conf;
+
+    /** Speex codec complexity? (default: 10) */
+    unsigned	complexity;
+
+    /** Speex codec quality? (default: 10) */
+    unsigned	quality;
+
+    /** Codec ptime? (default: 0 (follows the codec)) */
+    unsigned	ptime;
+
+    /** Number of additional codecs/"--add-codec" with pjsua (default: 0) */
+    unsigned	codec_cnt;
+
+    /** Additional codecs/"--add-codec" options */
+    pj_str_t	codec_arg[32];
+
+    /** SIP status code to be automatically sent to incoming calls
+     *  (default: 100).
+     */
+    unsigned	auto_answer;
+
+    /** Periodic time to refresh call with re-INVITE (default: 0)
+     */
+    unsigned	uas_refresh;
+
+    /** Maximum incoming call duration (default: 3600) */
+    unsigned	uas_duration;
+
+    /** Outbound proxy (default: none) */
+    pj_str_t	outbound_proxy;
+
+    /** URI to call.			*/
+    pj_str_t	uri_to_call;
+
+    /** Number of SIP accounts */
+    unsigned	acc_cnt;
+
+    /** SIP accounts configuration */
+    pjsua_acc_config	acc_config[32];
+
+    /** Logging verbosity (default: 5).	*/
+    unsigned	log_level;
+
+    /** Logging to be displayed to stdout (default: 4) */
+    unsigned	app_log_level;
+
+    /** Log decoration */
+    unsigned	log_decor;
+
+    /** Optional log filename (default: NULL) */
+    pj_str_t	log_filename;
+
+    /** Number of buddies in address book (default: 0) */
+    unsigned	buddy_cnt;
+
+    /** Buddies URI */
+    pj_str_t	buddy_uri[256];
+};
+
+
+/**
+ * @see pjsua_config
+ */
+typedef struct pjsua_config pjsua_config;
+
+
+
+/**
+ * Application callbacks.
+ */
+struct pjsua_callback
+{
+    /**
+     * Notify UI when invite state has changed.
+     */
+    void (*on_call_state)(int call_index, pjsip_event *e);
+
+    /**
+     * Notify UI when registration status has changed.
+     */
+    void (*on_reg_state)(int acc_index);
+
+    /**
+     * Notify UI on incoming pager (i.e. MESSAGE request).
+     * Argument call_index will be -1 if MESSAGE request is not related to an 
+     * existing call.
+     */
+    void (*on_pager)(int call_index, const pj_str_t *from,
+		     const pj_str_t *to, const pj_str_t *txt);
+
+    /**
+     * Notify UI about typing indication.
+     */
+    void (*on_typing)(int call_index, const pj_str_t *from,
+		      const pj_str_t *to, pj_bool_t is_typing);
+
+};
+
+/**
+ * @see pjsua_callback
+ */
+typedef struct pjsua_callback pjsua_callback;
 
 
@@ -179,77 +379,33 @@
     pj_pool_t	    *pool;	    /**< pjsua's private pool.		*/
     pjsip_module     mod;	    /**< pjsua's PJSIP module.		*/
+
     
+    /* Config: */
+    pjsua_config    config;	    /**< PJSUA configs			*/
+
+    /* Application callback: */
+    pjsua_callback  cb;		    /**< Application callback.		*/
 
     /* Media:  */
-    int		     start_rtp_port;/**< Start of RTP port to try.	*/
     pjmedia_endpt   *med_endpt;	    /**< Media endpoint.		*/
-    unsigned	     clock_rate;    /**< Internal clock rate.		*/
     pjmedia_conf    *mconf;	    /**< Media conference.		*/
-    pj_bool_t	     null_audio;    /**< Null audio flag.		*/
-    pj_bool_t	     no_mic;	    /**< Disable microphone.		*/
-    char	    *wav_file;	    /**< WAV file name to play.		*/
     unsigned	     wav_slot;	    /**< WAV player slot in bridge	*/
     pjmedia_port    *file_port;	    /**< WAV player port.		*/
-    pjmedia_port    *null_port;	    /**< NULL port.			*/
-    pj_bool_t	     auto_play;	    /**< Auto play file for calls?	*/
-    pj_bool_t	     auto_loop;	    /**< Auto loop RTP stream?		*/
-    pj_bool_t	     auto_conf;	    /**< Auto put to conference?	*/
-    int		     complexity;    /**< Codec complexity.		*/
-    int		     quality;	    /**< Codec quality.			*/
-    int		     ptime;	    /**< Codec ptime in msec.		*/
-
-
-    /* Codec arguments: */
-    int		     codec_cnt;	    /**< Number of --add-codec args.	*/
-    pj_str_t	     codec_arg[32]; /**< Array of --add-codec args.	*/
-    pj_status_t	    (*codec_deinit[32])(void);	/**< Array of funcs.	*/
-
-    /* User Agent behaviour: */
-    int		     auto_answer;   /**< Automatically answer in calls.	*/
-    int		     uas_refresh;   /**< Time to re-INVITE.		*/
-    int		     uas_duration;  /**< Max call duration.		*/
+
 
     /* Account: */
-    pj_bool_t	     has_acc;	    /**< Any --id cmdline?		*/
-    int		     acc_cnt;	    /**< Number of client registrations	*/
     pjsua_acc	     acc[PJSUA_MAX_ACC];    /** Client regs array.	*/
 
 
-    /* Authentication credentials: */
-
-    int		     cred_count;    /**< Number of credentials.		*/
-    pjsip_cred_info  cred_info[10]; /**< Array of credentials.		*/
-
-
     /* Threading (optional): */
-    int		     thread_cnt;    /**< Thread count.			*/
     pj_thread_t	    *threads[8];    /**< Thread instances.		*/
     pj_bool_t	     quit_flag;	    /**< To signal thread to quit.	*/
 
     /* Transport (UDP): */
-    pj_uint16_t	     sip_port;	    /**< SIP signaling port.		*/
     pj_sock_t	     sip_sock;	    /**< SIP UDP socket.		*/
     pj_sockaddr_in   sip_sock_name; /**< Public/STUN UDP socket addr.	*/
 
-    pj_str_t	     outbound_proxy;/**< Outbound proxy.		*/
-
-
-    /* STUN: */
-    pj_str_t	     stun_srv1;
-    int		     stun_port1;
-    pj_str_t	     stun_srv2;
-    int		     stun_port2;
-
-
-    /* Logging: */    
-    int		     log_level;	    /**< Logging verbosity.		*/
-    int		     app_log_level; /**< stdout log verbosity.		*/
-    unsigned	     log_decor;	    /**< Log decoration.		*/
-    char	    *log_filename;  /**< Log filename.			*/
-
 
     /* PJSUA Calls: */
-    pj_str_t	     uri_to_call;   /**< URI to call.			*/
-    int		     max_calls;	    /**< Max nb of calls.		*/
     int		     call_cnt;	    /**< Number of calls.		*/
     pjsua_call	     calls[PJSUA_MAX_CALLS];	/** Calls array.	*/
@@ -274,24 +430,33 @@
  * Initialize pjsua settings with default parameters.
  */
-void pjsua_default(void);
-
-
-/**
- * Display error message for the specified error code.
- */
-void pjsua_perror(const char *sender, const char *title, 
-		  pj_status_t status);
-
-
-/**
- * Initialize pjsua application. Application can call this before parsing
- * application settings.
+PJ_DECL(void) pjsua_default_config(pjsua_config *cfg);
+
+
+/**
+ * Test configuration.
+ */
+PJ_DECL(pj_status_t) pjsua_test_config(const pjsua_config *cfg,
+				       char *errmsg,
+				       int len);
+
+
+/**
+ * Create pjsua application.
+ * This initializes pjlib/pjlib-util, and creates memory pool factory to
+ * be used by application.
+ */
+PJ_DECL(pj_status_t) pjsua_create(void);
+
+
+/**
+ * Initialize pjsua application with the specified settings.
  *
  * This will initialize all libraries, create endpoint instance, and register
- * pjsip modules. Transport will NOT be created however.
+ * pjsip modules. 
  *
  * Application may register module after calling this function.
  */
-pj_status_t pjsua_init(void);
+PJ_DECL(pj_status_t) pjsua_init(const pjsua_config *cfg,
+				const pjsua_callback *cb);
 
 
@@ -303,5 +468,5 @@
  * process, if registration is configured.
  */
-pj_status_t pjsua_start(void);
+PJ_DECL(pj_status_t) pjsua_start(void);
 
 
@@ -309,17 +474,5 @@
  * Destroy pjsua.
  */
-pj_status_t pjsua_destroy(void);
-
-
-/**
- * Find account for incoming request.
- */
-int pjsua_find_account_for_incoming(pjsip_rx_data *rdata);
-
-
-/**
- * Find account for outgoing request.
- */
-int pjsua_find_account_for_outgoing(const pj_str_t *url);
+PJ_DECL(pj_status_t) pjsua_destroy(void);
 
 
@@ -329,20 +482,9 @@
 
 /**
- * Init pjsua call module.
- */
-pj_status_t pjsua_call_init(void);
-
-/**
  * Make outgoing call.
  */
-pj_status_t pjsua_make_call(int acc_index,
-			    const char *cstr_dest_uri,
-			    int *p_call_index);
-
-
-/**
- * Handle incoming invite request.
- */
-pj_bool_t pjsua_call_on_incoming(pjsip_rx_data *rdata);
+PJ_DECL(pj_status_t) pjsua_make_call(int acc_index,
+				     const char *cstr_dest_uri,
+				     int *p_call_index);
 
 
@@ -350,10 +492,10 @@
  * Answer call.
  */
-void pjsua_call_answer(int call_index, int code);
+PJ_DECL(void) pjsua_call_answer(int call_index, int code);
 
 /**
  * Hangup call.
  */
-void pjsua_call_hangup(int call_index);
+PJ_DECL(void) pjsua_call_hangup(int call_index);
 
 
@@ -361,5 +503,5 @@
  * Put call on-hold.
  */
-void pjsua_call_set_hold(int call_index);
+PJ_DECL(void) pjsua_call_set_hold(int call_index);
 
 
@@ -367,5 +509,5 @@
  * Send re-INVITE (to release hold).
  */
-void pjsua_call_reinvite(int call_index);
+PJ_DECL(void) pjsua_call_reinvite(int call_index);
 
 
@@ -373,5 +515,5 @@
  * Transfer call.
  */
-void pjsua_call_xfer(int call_index, const char *dest);
+PJ_DECL(void) pjsua_call_xfer(int call_index, const char *dest);
 
 
@@ -379,5 +521,5 @@
  * Send instant messaging inside INVITE session.
  */
-void pjsua_call_send_im(int call_index, const char *text);
+PJ_DECL(void) pjsua_call_send_im(int call_index, const char *text);
 
 
@@ -385,10 +527,10 @@
  * Send IM typing indication inside INVITE session.
  */
-void pjsua_call_typing(int call_index, pj_bool_t is_typing);
+PJ_DECL(void) pjsua_call_typing(int call_index, pj_bool_t is_typing);
 
 /**
  * Terminate all calls.
  */
-void pjsua_call_hangup_all(void);
+PJ_DECL(void) pjsua_call_hangup_all(void);
 
 
@@ -398,15 +540,8 @@
 
 /**
- * Initialize client registration session.
- *
- * @param app_callback	Optional callback
- */
-pj_status_t pjsua_regc_init(int acc_index);
-
-/**
  * Update registration or perform unregistration. If renew argument is zero,
  * this will start unregistration process.
  */
-void pjsua_regc_update(int acc_index, pj_bool_t renew);
+PJ_DECL(void) pjsua_regc_update(int acc_index, pj_bool_t renew);
 
 
@@ -418,22 +553,12 @@
 
 /**
- * Init presence.
- */
-pj_status_t pjsua_pres_init();
-
-/**
  * Refresh both presence client and server subscriptions.
  */
-void pjsua_pres_refresh(int acc_index);
-
-/**
- * Terminate all subscriptions
- */
-void pjsua_pres_shutdown(void);
+PJ_DECL(void) pjsua_pres_refresh(int acc_index);
 
 /**
  * Dump presence subscriptions.
  */
-void pjsua_pres_dump(pj_bool_t detail);
+PJ_DECL(void) pjsua_pres_dump(pj_bool_t detail);
 
 
@@ -448,20 +573,10 @@
 
 
-/**
- * Init IM module handler to handle incoming MESSAGE outside dialog.
- */
-pj_status_t pjsua_im_init();
-
-
-/**
- * Create Accept header for MESSAGE.
- */
-pjsip_accept_hdr* pjsua_im_create_accept(pj_pool_t *pool);
 
 /**
  * Send IM outside dialog.
  */
-pj_status_t pjsua_im_send(int acc_index, const char *dst_uri, 
-			  const char *text);
+PJ_DECL(pj_status_t) pjsua_im_send(int acc_index, const char *dst_uri, 
+				   const char *text);
 
 
@@ -469,55 +584,7 @@
  * Send typing indication outside dialog.
  */
-pj_status_t pjsua_im_typing(int acc_index, const char *dst_uri, 
-			    pj_bool_t is_typing);
-
-
-/**
- * Private: check if we can accept the message.
- *	    If not, then p_accept header will be filled with a valid
- *	    Accept header.
- */
-pj_bool_t pjsua_im_accept_pager(pjsip_rx_data *rdata,
-				pjsip_accept_hdr **p_accept_hdr);
-
-/**
- * Private: process pager message.
- *	    This may trigger pjsua_ui_on_pager() or pjsua_ui_on_typing().
- */
-void pjsua_im_process_pager(int call_id, const pj_str_t *from,
-			    const pj_str_t *to, pjsip_rx_data *rdata);
-
-
-/*****************************************************************************
- * User Interface API.
- *
- * The UI API specifies functions that will be called by pjsua upon
- * occurence of various events.
- */
-
-/**
- * Notify UI when invite state has changed.
- */
-void pjsua_ui_on_call_state(int call_index, pjsip_event *e);
-
-/**
- * Notify UI when registration status has changed.
- */
-void pjsua_ui_on_reg_state(int acc_index);
-
-/**
- * Notify UI on incoming pager (i.e. MESSAGE request).
- * Argument call_index will be -1 if MESSAGE request is not related to an 
- * existing call.
- */
-void pjsua_ui_on_pager(int call_index, const pj_str_t *from,
-		       const pj_str_t *to, const pj_str_t *txt);
-
-
-/**
- * Notify UI about typing indication.
- */
-void pjsua_ui_on_typing(int call_index, const pj_str_t *from,
-		        const pj_str_t *to, pj_bool_t is_typing);
+PJ_DECL(pj_status_t) pjsua_im_typing(int acc_index, const char *dst_uri, 
+				     pj_bool_t is_typing);
+
 
 
@@ -533,20 +600,24 @@
  * Parse arguments (pjsua_opt.c).
  */
-pj_status_t pjsua_parse_args(int argc, char *argv[]);
+PJ_DECL(pj_status_t) pjsua_parse_args(int argc, char *argv[],
+				      pjsua_config *cfg);
 
 /**
  * Load settings from a file.
  */
-pj_status_t pjsua_load_settings(const char *filename);
+PJ_DECL(pj_status_t) pjsua_load_settings(const char *filename,
+					 pjsua_config *cfg);
 
 /**
  * Dump settings.
  */
-int pjsua_dump_settings(char *buf, pj_size_t max);
+PJ_DECL(int) pjsua_dump_settings(const pjsua_config *cfg,
+				 char *buf, pj_size_t max);
 
 /**
  * Save settings to a file.
  */
-pj_status_t pjsua_save_settings(const char *filename);
+PJ_DECL(pj_status_t) pjsua_save_settings(const char *filename,
+					 const pjsua_config *cfg);
 
 
@@ -555,10 +626,18 @@
  * @return  PJ_SUCCESS if valid.
  */
-pj_status_t pjsua_verify_sip_url(const char *c_url);
+PJ_DECL(pj_status_t) pjsua_verify_sip_url(const char *c_url);
 
 /*
  * Dump application states.
  */
-void pjsua_dump(pj_bool_t detail);
+PJ_DECL(void) pjsua_dump(pj_bool_t detail);
+
+/**
+ * Display error message for the specified error code.
+ */
+PJ_DECL(void) pjsua_perror(const char *sender, const char *title, 
+			   pj_status_t status);
+
+
 
 
Index: pjproject/trunk/pjsip/include/pjsua-lib/pjsua_console_app.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsua-lib/pjsua_console_app.h	(revision 476)
+++ pjproject/trunk/pjsip/include/pjsua-lib/pjsua_console_app.h	(revision 476)
@@ -0,0 +1,31 @@
+/* $Id$ */
+/* 
+ * Copyright (C) 2003-2006 Benny Prijono <benny@prijono.org>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
+#ifndef __PJSUA_CONSOLE_APP_H__
+#define __PJSUA_CONSOLE_APP_H__
+
+
+pj_status_t pjsua_console_app_logging_init(const pjsua_config *cfg);
+void pjsua_console_app_logging_shutdown(void);
+
+void pjsua_console_app_main(void);
+
+extern pjsip_module pjsua_console_app_msg_logger;
+extern pjsua_callback console_callback;
+
+#endif	/* __PJSUA_CONSOLE_APP_H__ */
Index: pjproject/trunk/pjsip/src/pjsip-ua/sip_reg.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip-ua/sip_reg.c	(revision 475)
+++ pjproject/trunk/pjsip/src/pjsip-ua/sip_reg.c	(revision 476)
@@ -485,4 +485,5 @@
     
     /* Decrement pending transaction counter. */
+    pj_assert(regc->pending_tsx > 0);
     --regc->pending_tsx;
 
@@ -610,8 +611,11 @@
     cseq_hdr->cseq = cseq;
 
-    /* Send. */
+    /* Increment pending transaction first, since transaction callback
+     * may be called even before send_request() returns!
+     */
+    ++regc->pending_tsx;
     status = pjsip_endpt_send_request(regc->endpt, tdata, -1, regc, &tsx_callback);
-    if (status==PJ_SUCCESS)
-	++regc->pending_tsx;
+    if (status!=PJ_SUCCESS)
+	--regc->pending_tsx;
 
     return status;
Index: pjproject/trunk/pjsip/src/pjsua-lib/pjsua_call.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsua-lib/pjsua_call.c	(revision 475)
+++ pjproject/trunk/pjsip/src/pjsua-lib/pjsua_call.c	(revision 476)
@@ -19,5 +19,5 @@
 #include <pjsua-lib/pjsua.h>
 #include <pj/log.h>
-
+#include "pjsua_imp.h"
 
 /*
@@ -57,5 +57,6 @@
 	} else {
 	    PJ_LOG(3,(THIS_FILE, "Refreshing call %d", call->index));
-	    schedule_call_timer(call,e,REFRESH_CALL_TIMER,pjsua.uas_refresh);
+	    schedule_call_timer(call,e,REFRESH_CALL_TIMER,
+				pjsua.config.uas_refresh);
 	    pjsua_call_reinvite(call->index);
 	}
@@ -127,7 +128,7 @@
  * Make outgoing call.
  */
-pj_status_t pjsua_make_call(int acc_index,
-			    const char *cstr_dest_uri,
-			    int *p_call_index)
+PJ_DEF(pj_status_t) pjsua_make_call(int acc_index,
+				    const char *cstr_dest_uri,
+				    int *p_call_index)
 {
     pj_str_t dest_uri;
@@ -135,5 +136,5 @@
     pjmedia_sdp_session *offer;
     pjsip_inv_session *inv = NULL;
-    int call_index = -1;
+    unsigned call_index;
     pjsip_tx_data *tdata;
     pj_status_t status;
@@ -144,10 +145,10 @@
 
     /* Find free call slot. */
-    for (call_index=0; call_index<pjsua.max_calls; ++call_index) {
+    for (call_index=0; call_index<pjsua.config.max_calls; ++call_index) {
 	if (pjsua.calls[call_index].inv == NULL)
 	    break;
     }
 
-    if (call_index == pjsua.max_calls) {
+    if (call_index == pjsua.config.max_calls) {
 	PJ_LOG(3,(THIS_FILE, "Error: too many calls!"));
 	return PJ_ETOOMANY;
@@ -162,6 +163,6 @@
     /* Create outgoing dialog: */
     status = pjsip_dlg_create_uac( pjsip_ua_instance(), 
-				   &pjsua.acc[acc_index].local_uri,
-				   &pjsua.acc[acc_index].contact_uri, 
+				   &pjsua.config.acc_config[acc_index].id,
+				   &pjsua.config.acc_config[acc_index].contact,
 				   &dest_uri, &dest_uri,
 				   &dlg);
@@ -205,7 +206,10 @@
 
     /* Set credentials: */
-
-    pjsip_auth_clt_set_credentials( &dlg->auth_sess, pjsua.cred_count, 
-				    pjsua.cred_info);
+    if (pjsua.config.acc_config[acc_index].cred_count) {
+	pjsua_acc_config *acc_cfg = &pjsua.config.acc_config[acc_index];
+	pjsip_auth_clt_set_credentials( &dlg->auth_sess, 
+					acc_cfg->cred_count,
+					acc_cfg->cred_info);
+    }
 
 
@@ -226,4 +230,10 @@
 	pjsua_perror(THIS_FILE, "Unable to send initial INVITE request", 
 		     status);
+
+	/* Upon failure to send first request, both dialog and invite 
+	 * session would have been cleared.
+	 */
+	inv = NULL;
+	dlg = NULL;
 	goto on_error;
     }
@@ -243,5 +253,5 @@
     if (inv != NULL) {
 	pjsip_inv_terminate(inv, PJSIP_SC_OK, PJ_FALSE);
-    } else {
+    } else if (dlg) {
 	pjsip_dlg_terminate(dlg);
     }
@@ -251,4 +261,34 @@
     }
     return status;
+}
+
+
+/**
+ * Answer call.
+ */
+PJ_DEF(void) pjsua_call_answer(int call_index, int code)
+{
+    pjsip_tx_data *tdata;
+    pj_status_t status;
+
+    PJ_ASSERT_ON_FAIL(call_index >= 0 && 
+		      call_index < (int)pjsua.config.max_calls,
+		      return);
+
+    if (pjsua.calls[call_index].inv == NULL) {
+	PJ_LOG(3,(THIS_FILE, "Call %d already disconnected"));
+	return;
+    }
+
+    status = pjsip_inv_answer(pjsua.calls[call_index].inv,
+			      code, NULL, NULL, &tdata);
+    if (status == PJ_SUCCESS)
+	status = pjsip_inv_send_msg(pjsua.calls[call_index].inv,
+				    tdata);
+
+    if (status != PJ_SUCCESS)
+	pjsua_perror(THIS_FILE, "Unable to create/send response", 
+		     status);
+
 }
 
@@ -266,5 +306,5 @@
     pjsip_inv_session *inv = NULL;
     int acc_index;
-    int call_index = -1;
+    unsigned call_index;
     pjmedia_sdp_session *answer;
     pj_status_t status;
@@ -313,5 +353,5 @@
 
     /* Find free call slot. */
-    for (call_index=0; call_index < pjsua.max_calls; ++call_index) {
+    for (call_index=0; call_index < pjsua.config.max_calls; ++call_index) {
 	if (pjsua.calls[call_index].inv == NULL)
 	    break;
@@ -354,5 +394,5 @@
 
     status = pjsip_dlg_create_uas( pjsip_ua_instance(), rdata,
-				   &pjsua.acc[acc_index].contact_uri, 
+				   &pjsua.config.acc_config[acc_index].contact,
 				   &dlg);
     if (status != PJ_SUCCESS) {
@@ -388,6 +428,6 @@
     
     status = pjsip_inv_initial_answer(inv, rdata, 
-				      (pjsua.auto_answer ? pjsua.auto_answer 
-					: 100), 
+				      (pjsua.config.auto_answer ? 
+				      pjsua.config.auto_answer : 100), 
 				      NULL, NULL, &response);
     if (status != PJ_SUCCESS) {
@@ -401,5 +441,5 @@
 	 * because SDP negotiation has failed.
 	 */
-	if (pjsua.auto_answer/100 == 2)
+	if (pjsua.config.auto_answer/100 == 2)
 	    st_code = PJSIP_SC_UNSUPPORTED_MEDIA_TYPE;
 	else
@@ -416,5 +456,5 @@
     }
 
-    if (pjsua.auto_answer < 200) {
+    if (pjsua.config.auto_answer < 200) {
 	PJ_LOG(3,(THIS_FILE,
 		  "\nIncoming call!!\n"
@@ -433,6 +473,6 @@
 		  (int)dlg->local.info_str.slen,
 		  dlg->local.info_str.ptr,
-		  pjsua.auto_answer,
-		  pjsip_get_status_text(pjsua.auto_answer)->ptr ));
+		  pjsua.config.auto_answer,
+		  pjsip_get_status_text(pjsua.config.auto_answer)->ptr ));
     }
 
@@ -440,17 +480,17 @@
 
     /* Schedule timer to refresh. */
-    if (pjsua.uas_refresh > 0) {
+    if (pjsua.config.uas_refresh > 0) {
 	schedule_call_timer( &pjsua.calls[call_index], 
 			     &pjsua.calls[call_index].refresh_tm,
 			     REFRESH_CALL_TIMER,
-			     pjsua.uas_refresh);
+			     pjsua.config.uas_refresh);
     }
 
     /* Schedule timer to hangup call. */
-    if (pjsua.uas_duration > 0) {
+    if (pjsua.config.uas_duration > 0) {
 	schedule_call_timer( &pjsua.calls[call_index], 
 			     &pjsua.calls[call_index].hangup_tm,
 			     HANGUP_CALL_TIMER,
-			     pjsua.uas_duration);
+			     pjsua.config.uas_duration);
     }
 
@@ -551,5 +591,6 @@
 
 
-    pjsua_ui_on_call_state(call->index, e);
+    if (pjsua.cb.on_call_state)
+	(*pjsua.cb.on_call_state)(call->index, e);
 
     /* call->inv may be NULL now */
@@ -966,5 +1007,5 @@
     }
 
-    if (pjsua.null_audio)
+    if (pjsua.config.null_audio)
 	return;
 
@@ -984,7 +1025,8 @@
 
     /* Override ptime, if this option is specified. */
-    if (pjsua.ptime) {
+    if (pjsua.config.ptime) {
 	sess_info.stream_info[0].param->setting.frm_per_pkt = (pj_uint8_t)
-	    (pjsua.ptime / sess_info.stream_info[0].param->info.frm_ptime);
+	    (pjsua.config.ptime / 
+	      sess_info.stream_info[0].param->info.frm_ptime);
 	if (sess_info.stream_info[0].param->setting.frm_per_pkt==0)
 	    sess_info.stream_info[0].param->setting.frm_per_pkt = 1;
@@ -1038,5 +1080,5 @@
      * port 
      */
-    if (pjsua.auto_play && pjsua.wav_file && 
+    if (pjsua.config.auto_play && pjsua.config.wav_file.slen && 
 	call->inv->role == PJSIP_ROLE_UAS) 
     {
@@ -1046,5 +1088,5 @@
 
     }
-    if (pjsua.auto_loop && call->inv->role == PJSIP_ROLE_UAS) {
+    if (pjsua.config.auto_loop && call->inv->role == PJSIP_ROLE_UAS) {
 
 	pjmedia_conf_connect_port( pjsua.mconf, call->conf_slot, 
@@ -1052,11 +1094,11 @@
 
     }
-    if (pjsua.auto_conf) {
-	int i;
+    if (pjsua.config.auto_conf) {
+	unsigned i;
 
 	pjmedia_conf_connect_port( pjsua.mconf, 0, call->conf_slot, 0);
 	pjmedia_conf_connect_port( pjsua.mconf, call->conf_slot, 0, 0);
 
-	for (i=0; i < pjsua.max_calls; ++i) {
+	for (i=0; i < pjsua.config.max_calls; ++i) {
 
 	    if (!pjsua.calls[i].session)
@@ -1074,6 +1116,6 @@
      * the sound device port (port zero) in the main conference bridge.
      */
-    if (pjsua.auto_play == 0 && pjsua.auto_loop == 0 &&
-	pjsua.auto_conf == 0)
+    if (pjsua.config.auto_play == 0 && pjsua.config.auto_loop == 0 &&
+	pjsua.config.auto_conf == 0)
     {
 	pjmedia_conf_connect_port( pjsua.mconf, 0, call->conf_slot, 0);
@@ -1128,5 +1170,5 @@
  * Hangup call.
  */
-void pjsua_call_hangup(int call_index)
+PJ_DEF(void) pjsua_call_hangup(int call_index)
 {
     pjsua_call *call;
@@ -1178,5 +1220,5 @@
  * Put call on-Hold.
  */
-void pjsua_call_set_hold(int call_index)
+PJ_DEF(void) pjsua_call_set_hold(int call_index)
 {
     pjmedia_sdp_session *sdp;
@@ -1219,5 +1261,5 @@
  * re-INVITE.
  */
-void pjsua_call_reinvite(int call_index)
+PJ_DEF(void) pjsua_call_reinvite(int call_index)
 {
     pjmedia_sdp_session *sdp;
@@ -1266,5 +1308,5 @@
  * Transfer call.
  */
-void pjsua_call_xfer(int call_index, const char *dest)
+PJ_DEF(void) pjsua_call_xfer(int call_index, const char *dest)
 {
     pjsip_evsub *sub;
@@ -1318,5 +1360,5 @@
  * Send instant messaging inside INVITE session.
  */
-void pjsua_call_send_im(int call_index, const char *str)
+PJ_DECL(void) pjsua_call_send_im(int call_index, const char *str)
 {
     pjsua_call *call;
@@ -1374,5 +1416,5 @@
  * Send IM typing indication inside INVITE session.
  */
-void pjsua_call_typing(int call_index, pj_bool_t is_typing)
+PJ_DECL(void) pjsua_call_typing(int call_index, pj_bool_t is_typing)
 {
     pjsua_call *call;
@@ -1416,9 +1458,9 @@
  * Terminate all calls.
  */
-void pjsua_call_hangup_all(void)
-{
-    int i;
-
-    for (i=0; i<pjsua.max_calls; ++i) {
+PJ_DEF(void) pjsua_call_hangup_all(void)
+{
+    unsigned i;
+
+    for (i=0; i<pjsua.config.max_calls; ++i) {
 	pjsip_tx_data *tdata;
 	int st_code;
